
/*  A Bison parser, made from /home/gray/radius-0.96-series/radiusd/./config.y
 by  GNU Bison version 1.27
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	EOL	257
#define	T_ALLOW	258
#define	T_AUTH	259
#define	T_CATEGORY	260
#define	T_DENY	261
#define	T_DETAIL	262
#define	T_EXPWARNING	263
#define	T_FILE	264
#define	T_GUILE	265
#define	T_INFO	266
#define	T_IDENT	267
#define	T_LEVEL	268
#define	T_LISTEN	269
#define	T_LOGGING	270
#define	T_NETWORK	271
#define	T_MAIN	272
#define	T_OPTION	273
#define	T_USEDBM	274
#define	T_CHECKRAD_ASSUME_LOGGED	275
#define	T_DELAY	276
#define	T_HOST	277
#define	T_EXEC_PROGRAM_GROUP	278
#define	T_EXEC_PROGRAM_USER	279
#define	T_LOAD	280
#define	T_LOAD_PATH	281
#define	T_LOG_DIR	282
#define	T_MAX_REQUESTS	283
#define	T_MESSAGE	284
#define	T_PORT	285
#define	T_REQUEST_CLEANUP_DELAY	286
#define	T_RETRY	287
#define	T_SPAWN	288
#define	T_STRIP_NAMES	289
#define	T_TTL	290
#define	T_USERNAME_CHARS	291
#define	T_USR2DELAY	292
#define	T_SOURCE_IP	293
#define	T_ACCT_DIR	294
#define	T_ACCT	295
#define	T_CNTL	296
#define	T_PROXY	297
#define	T_CHANNEL	298
#define	T_SYSLOG	299
#define	T_NOTIFY	300
#define	T_SNMP	301
#define	T_COMMUNITY	302
#define	T_ACL	303
#define	T_FACILITY	304
#define	T_LOGLEVEL	305
#define	T_LOGOPT	306
#define	T_SEVERITY	307
#define	T_SNMP_ACCESS	308
#define	T_NUMBER	309
#define	T_IPADDR	310
#define	T_STRING	311
#define	T_BOOL	312
#define	T_MESGDEF	313

#line 1 "config.y"

/* This file is part of GNU RADIUS.
   Copyright (C) 2000,2001, Sergey Poznyakoff
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

#ifndef lint
static char rcsid[] = 
	"@(#) $Id: config.y,v 1.30.2.1 2002/03/19 15:10:18 gray Exp $";
#endif

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <netinet/in.h>

#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <ctype.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <syslog.h> 
#include <radiusd.h>
 
#define YYMAXDEPTH 16

#ifdef USE_SNMP
typedef struct netlist Netlist;
struct netlist {
	Netlist *next;
	char *name;
	ACL *acl;
};
static Netlist *netlist;
#endif

#define AT_ANY    0
#define AT_INT    1
#define AT_STRING 2
#define AT_IPADDR 3
#define AT_BOOL   4
#define AT_PORT   5
 
static char *typestr[] = {
	"any",
	"numeric",
	"string",
	"IP address",
	"boolean",
	"port"
};

static int syslog_severity[] = {
	LOG_ALERT,
	LOG_CRIT,    
	LOG_DEBUG,   
	LOG_EMERG,   
	LOG_ERR,     
	LOG_INFO,    
	LOG_NOTICE,  
	LOG_WARNING,
};
	 
struct category_def {
	Chanlist *head, *tail;
	int level;
} cat_def;

extern time_t delayed_hup_wait;
extern int keyword();

static char *filename;
static char line_num;
static char *buffer;
static char *curp;
static int expect_string; 
static int in_category;

static Channel channel;

static void skipws();
static void skipline();
static void skipstmt();
static int isword(int c);
static void copy_alpha();
static void copy_string();
static int copy_digit();

#ifdef USE_SNMP
static char * ident_string(char *);
static void add_netlist(char *name, ACL *list);
static void free_netlist();
static ACL *find_netlist(char*);
#endif

static int cclex();
static void putback(char *tok, int length);

static int got_listen;
static int first_time = 1;
static int debug_config;

static void asgn(void *base, Value *value, int type, int once);

#line 125 "config.y"
typedef union {
	int number;
	int bool;
	UINT4 ipaddr;
	char string[256];
	char *sptr;
	Value value;
	HOSTDECL hostdecl;
	struct {
		HOSTDECL *head;
		HOSTDECL *tail;
	} hostlist;
	struct {
		int cat;
		int pri;
	} category_name;
#ifdef USE_SNMP
	struct {
		ACL *head, *tail;
	} netlist;
	ACL *acl;
#else
	int netlist, acl;
#endif
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		344
#define	YYFLAG		-32768
#define	YYNTBASE	69

#define YYTRANSLATE(x) ((unsigned)(x) <= 313 ? cctranslate[x] : 148)

static const char cctranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    65,     2,     2,     2,     2,     2,     2,     2,
     2,    63,     2,    66,     2,    62,    67,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    68,     2,     2,
    64,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    60,     2,    61,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59
};

#if YYDEBUG != 0
static const short ccprhs[] = {     0,
     0,     2,     4,     7,     9,    12,    15,    17,    19,    21,
    23,    25,    27,    29,    31,    33,    35,    37,    42,    44,
    47,    51,    53,    56,    59,    62,    65,    68,    71,    74,
    77,    80,    82,    84,    89,    91,    93,    96,   100,   102,
   105,   107,   110,   113,   116,   119,   122,   125,   128,   131,
   134,   139,   141,   143,   146,   150,   152,   155,   157,   160,
   163,   166,   169,   172,   175,   180,   182,   185,   189,   191,
   194,   197,   200,   205,   207,   210,   212,   215,   218,   221,
   227,   228,   231,   233,   236,   238,   242,   248,   252,   253,
   258,   260,   262,   264,   270,   272,   274,   276,   278,   282,
   286,   288,   290,   292,   294,   296,   298,   300,   303,   306,
   308,   311,   315,   316,   321,   325,   329,   331,   333,   337,
   339,   343,   346,   351,   353,   355,   359,   361,   363,   366,
   368,   370,   373,   377,   379,   382,   385,   388,   391,   394,
   397,   400,   404,   408,   410,   415,   417,   420,   424,   426,
   429,   433,   436,   438,   440,   442,   444,   446,   449,   453,
   455,   459,   461,   465,   470,   472,   475,   479,   483,   487,
   492,   494,   497,   501,   505,   509,   511,   515,   517,   522,
   524,   526,   529,   533,   535,   538,   541,   546,   549,   551,
   554,   558,   560,   563,   566,   569,   572
};

static const short ccrhs[] = {    70,
     0,    71,     0,    70,    71,     0,     3,     0,    72,     3,
     0,     1,     3,     0,    92,     0,    73,     0,   144,     0,
   114,     0,    78,     0,    83,     0,    88,     0,   139,     0,
   115,     0,   131,     0,   134,     0,    19,    60,    74,    61,
     0,    75,     0,    74,    75,     0,    74,     1,    77,     0,
     3,     0,    76,     3,     0,    39,   127,     0,    38,   127,
     0,    29,   127,     0,    28,   127,     0,    40,   127,     0,
    25,   127,     0,    24,   127,     0,    37,   127,     0,     3,
     0,    61,     0,    79,    60,    80,    61,     0,     5,     0,
    81,     0,    80,    81,     0,    80,     1,    77,     0,     3,
     0,    82,     3,     0,   128,     0,    31,   127,     0,    34,
   127,     0,    36,   127,     0,    29,   127,     0,    32,   127,
     0,     8,   127,     0,    35,   127,     0,    21,   127,     0,
     9,   127,     0,    84,    60,    85,    61,     0,    41,     0,
    86,     0,    85,    86,     0,    85,     1,    77,     0,     3,
     0,    87,     3,     0,   128,     0,    31,   127,     0,    34,
   127,     0,    36,   127,     0,    29,   127,     0,    32,   127,
     0,     8,   127,     0,    43,    60,    89,    61,     0,    90,
     0,    89,    90,     0,    89,     1,    77,     0,     3,     0,
    91,     3,     0,    29,   127,     0,    32,   127,     0,    16,
    60,    93,    61,     0,    94,     0,    93,    94,     0,     3,
     0,    95,     3,     0,   102,     3,     0,     1,     3,     0,
    44,    96,    60,    98,    61,     0,     0,    97,    57,     0,
    99,     0,    98,    99,     0,     3,     0,    10,    57,     3,
     0,    45,   101,    62,    53,     3,     0,    52,    58,     3,
     0,     0,    19,   100,   137,     3,     0,    50,     0,     5,
     0,    55,     0,     6,   105,   103,   108,   104,     0,    60,
     0,    61,     0,   106,     0,   107,     0,   106,    62,   107,
     0,   106,    62,    63,     0,    18,     0,     5,     0,    41,
     0,    47,     0,    43,     0,    63,     0,    53,     0,    64,
    53,     0,    65,    53,     0,   109,     0,   108,   109,     0,
   108,     1,    61,     0,     0,    44,   110,    57,     3,     0,
    51,    58,     3,     0,   111,   112,     3,     0,    14,     0,
   113,     0,   112,    66,   113,     0,    57,     0,    57,    64,
    55,     0,    20,    58,     0,    47,    60,   120,    61,     0,
    56,     0,    55,     0,    56,    67,   116,     0,    56,     0,
   117,     0,   118,   117,     0,    57,     0,   121,     0,   120,
   121,     0,   120,     1,    77,     0,     3,     0,   122,     3,
     0,    13,    57,     0,    31,   127,     0,    34,   127,     0,
    36,   127,     0,    29,   127,     0,    32,   127,     0,    48,
    57,    54,     0,    17,    57,   118,     0,   123,     0,    49,
    60,   124,    61,     0,   125,     0,   124,   125,     0,   124,
     1,    77,     0,     3,     0,   126,     3,     0,     4,   119,
    57,     0,     7,   119,     0,    57,     0,    56,     0,    63,
     0,    58,     0,    55,     0,    15,   129,     0,    15,   129,
     1,     0,   130,     0,   129,    66,   130,     0,   127,     0,
   127,    68,   127,     0,    11,    60,   132,    61,     0,   133,
     0,   132,   133,     0,    27,   127,     3,     0,    26,   127,
     3,     0,    53,   127,     3,     0,    30,    60,   135,    61,
     0,   136,     0,   135,   136,     0,   135,     1,    77,     0,
    59,   127,     3,     0,     9,   127,     3,     0,   138,     0,
   137,    66,   138,     0,    57,     0,   140,    60,   141,    61,
     0,    42,     0,   142,     0,   141,   142,     0,   141,     1,
    77,     0,     3,     0,   143,     3,     0,    31,   127,     0,
    46,    60,   145,    61,     0,    46,    58,     0,   146,     0,
   145,   146,     0,   145,     1,    77,     0,     3,     0,   147,
     3,     0,    23,   127,     0,    31,   127,     0,    33,   127,
     0,    22,   127,     0
};

#endif

#if YYDEBUG != 0
static const short ccrline[] = { 0,
   183,   186,   187,   190,   191,   192,   199,   200,   201,   202,
   203,   204,   205,   206,   207,   208,   209,   213,   216,   217,
   218,   224,   225,   227,   231,   235,   239,   243,   247,   251,
   257,   263,   264,   271,   278,   284,   285,   286,   292,   293,
   296,   302,   306,   310,   314,   319,   324,   328,   332,   337,
   344,   351,   357,   358,   359,   365,   366,   369,   375,   379,
   383,   387,   392,   397,   405,   408,   409,   410,   416,   417,
   420,   425,   434,   437,   438,   441,   442,   443,   444,   455,
   470,   471,   478,   479,   482,   483,   488,   493,   500,   500,
   510,   511,   515,   521,   540,   547,   550,   556,   562,   568,
   576,   580,   584,   588,   592,   596,   602,   606,   610,   616,
   617,   618,   628,   628,   645,   652,   660,   674,   675,   681,
   708,   722,   738,   748,   749,   759,   769,   781,   787,   797,
   811,   812,   813,   820,   821,   824,   832,   838,   844,   850,
   857,   864,   876,   882,   885,   888,   889,   890,   897,   898,
   901,   913,   923,   929,   934,   939,   944,   951,   955,   963,
   971,   982,   987,   994,  1006,  1007,  1010,  1021,  1033,  1050,
  1053,  1054,  1055,  1061,  1065,  1072,  1073,  1079,  1093,  1096,
  1104,  1105,  1106,  1112,  1113,  1116,  1119,  1125,  1133,  1134,
  1135,  1142,  1143,  1146,  1147,  1148,  1149
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const cctname[] = {   "$","error","$undefined.","EOL","T_ALLOW",
"T_AUTH","T_CATEGORY","T_DENY","T_DETAIL","T_EXPWARNING","T_FILE","T_GUILE",
"T_INFO","T_IDENT","T_LEVEL","T_LISTEN","T_LOGGING","T_NETWORK","T_MAIN","T_OPTION",
"T_USEDBM","T_CHECKRAD_ASSUME_LOGGED","T_DELAY","T_HOST","T_EXEC_PROGRAM_GROUP",
"T_EXEC_PROGRAM_USER","T_LOAD","T_LOAD_PATH","T_LOG_DIR","T_MAX_REQUESTS","T_MESSAGE",
"T_PORT","T_REQUEST_CLEANUP_DELAY","T_RETRY","T_SPAWN","T_STRIP_NAMES","T_TTL",
"T_USERNAME_CHARS","T_USR2DELAY","T_SOURCE_IP","T_ACCT_DIR","T_ACCT","T_CNTL",
"T_PROXY","T_CHANNEL","T_SYSLOG","T_NOTIFY","T_SNMP","T_COMMUNITY","T_ACL","T_FACILITY",
"T_LOGLEVEL","T_LOGOPT","T_SEVERITY","T_SNMP_ACCESS","T_NUMBER","T_IPADDR","T_STRING",
"T_BOOL","T_MESGDEF","'{'","'}'","'.'","'*'","'='","'!'","','","'/'","':'","input",
"list","line","stmt","options_stmt","option_list","option_line","option_def",
"errmark","auth_stmt","auth","auth_list","auth_line","auth_def","acct_stmt",
"acct","acct_list","acct_line","acct_def","proxy_stmt","proxy_list","proxy_line",
"proxy_def","logging_stmt","logging_list","logging","channel_stmt","channel_name",
"@1","channel_list","channel_def","@2","facility","category_stmt","begin","end",
"category_name","category","severity","category_list","category_def","@3","begin_level",
"level_list","level","usedbm_stmt","snmp_stmt","netmask","network","netlist",
"acl","snmp_list","snmp_line","snmp_def","acl_stmt","acl_list","acl_line","acl_def",
"value","listen_stmt","hostlist","host","guile_stmt","guile_list","guile_def",
"message_stmt","message_list","message_line","obs_option_list","obs_option_string",
"cntl_stmt","cntl","cntl_list","cntl_line","cntl_def","notify_stmt","notify_list",
"notify_line","notify_def", NULL
};
#endif

static const short ccr1[] = {     0,
    69,    70,    70,    71,    71,    71,    72,    72,    72,    72,
    72,    72,    72,    72,    72,    72,    72,    73,    74,    74,
    74,    75,    75,    76,    76,    76,    76,    76,    76,    76,
    76,    77,    77,    78,    79,    80,    80,    80,    81,    81,
    82,    82,    82,    82,    82,    82,    82,    82,    82,    82,
    83,    84,    85,    85,    85,    86,    86,    87,    87,    87,
    87,    87,    87,    87,    88,    89,    89,    89,    90,    90,
    91,    91,    92,    93,    93,    94,    94,    94,    94,    95,
    97,    96,    98,    98,    99,    99,    99,    99,   100,    99,
   101,   101,   101,   102,   103,   104,   105,   105,   105,   105,
   106,   106,   106,   106,   106,   106,   107,   107,   107,   108,
   108,   108,   110,   109,   109,   109,   111,   112,   112,   113,
   113,   114,   115,   116,   116,   117,   117,   118,   118,   119,
   120,   120,   120,   121,   121,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   123,   124,   124,   124,   125,   125,
   126,   126,   127,   127,   127,   127,   127,   128,   128,   129,
   129,   130,   130,   131,   132,   132,   133,   133,   133,   134,
   135,   135,   135,   136,   136,   137,   137,   138,   139,   140,
   141,   141,   141,   142,   142,   143,   144,   144,   145,   145,
   145,   146,   146,   147,   147,   147,   147
};

static const short ccr2[] = {     0,
     1,     1,     2,     1,     2,     2,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     4,     1,     2,
     3,     1,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     1,     1,     4,     1,     1,     2,     3,     1,     2,
     1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     4,     1,     1,     2,     3,     1,     2,     1,     2,     2,
     2,     2,     2,     2,     4,     1,     2,     3,     1,     2,
     2,     2,     4,     1,     2,     1,     2,     2,     2,     5,
     0,     2,     1,     2,     1,     3,     5,     3,     0,     4,
     1,     1,     1,     5,     1,     1,     1,     1,     3,     3,
     1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
     2,     3,     0,     4,     3,     3,     1,     1,     3,     1,
     3,     2,     4,     1,     1,     3,     1,     1,     2,     1,
     1,     2,     3,     1,     2,     2,     2,     2,     2,     2,
     2,     3,     3,     1,     4,     1,     2,     3,     1,     2,
     3,     2,     1,     1,     1,     1,     1,     2,     3,     1,
     3,     1,     3,     4,     1,     2,     3,     3,     3,     4,
     1,     2,     3,     3,     3,     1,     3,     1,     4,     1,
     1,     2,     3,     1,     2,     2,     4,     2,     1,     2,
     3,     1,     2,     2,     2,     2,     2
};

static const short ccdefact[] = {     0,
     0,     4,    35,     0,     0,     0,     0,     0,    52,   180,
     0,     0,     0,     0,     2,     0,     8,    11,     0,    12,
     0,    13,     7,    10,    15,    16,    17,    14,     0,     9,
     6,     0,     0,     0,   122,     0,     0,   188,     0,     0,
     3,     5,     0,     0,     0,     0,     0,     0,     0,   165,
     0,    76,     0,    81,     0,    74,     0,     0,    22,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    19,     0,
     0,     0,     0,   171,    69,     0,     0,     0,    66,     0,
   192,     0,     0,     0,     0,     0,   189,     0,   134,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   131,
     0,   144,    39,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    36,     0,    41,    56,     0,     0,
     0,     0,     0,     0,     0,    53,     0,    58,   184,     0,
     0,   181,     0,   157,   154,   153,   156,   155,     0,     0,
     0,   164,   166,    79,   102,   101,   103,   105,   104,   107,
   106,     0,     0,     0,    97,    98,     0,     0,    73,    75,
    77,    78,    30,    29,    27,    26,    31,    25,    24,    28,
     0,    18,    20,    23,     0,     0,     0,   170,   172,    71,
    72,     0,    65,    67,    70,   197,   194,   195,   196,     0,
   187,   190,   193,   136,     0,   140,   137,   141,   138,   139,
     0,     0,     0,   123,   132,   135,    47,    50,   162,     0,
   160,    49,    45,    42,    46,    43,    48,    44,     0,    34,
    37,    40,    64,    62,    59,    63,    60,    61,     0,    51,
    54,    57,   186,     0,   179,   182,   185,   168,   167,   169,
   108,   109,    95,     0,     0,     0,    82,    32,    33,    21,
   175,   174,   173,    68,   191,   127,   128,   143,   142,   149,
     0,     0,     0,   146,     0,   133,     0,   159,     0,    38,
    55,   183,   117,   113,     0,     0,   110,     0,   100,    99,
    85,     0,    89,     0,     0,     0,    83,     0,   129,   130,
     0,   152,     0,   145,   147,   150,   163,   161,     0,     0,
     0,    96,    94,   111,   120,     0,   118,     0,     0,    92,
    91,    93,     0,     0,    80,    84,   125,   124,   126,   151,
   148,     0,   115,   112,     0,   116,     0,    86,   178,     0,
   176,     0,    88,   114,   121,   119,    90,     0,     0,   177,
    87,     0,     0,     0
};

static const short ccdefgoto[] = {   342,
    14,    15,    16,    17,    68,    69,    70,   250,    18,    19,
   114,   115,   116,    20,    21,   125,   126,   127,    22,    78,
    79,    80,    23,    55,    56,    57,   157,   158,   286,   287,
   309,   313,    58,   244,   303,   154,   155,   156,   276,   277,
   299,   278,   306,   307,    24,    25,   319,   257,   258,   291,
    99,   100,   101,   102,   263,   264,   265,   209,   117,   210,
   211,    26,    49,    50,    27,    73,    74,   330,   331,    28,
    29,   131,   132,   133,    30,    86,    87,    88
};

static const short ccpact[] = {   217,
    20,-32768,-32768,   -33,   -18,   -17,   -14,   -15,-32768,-32768,
    -9,   -47,    -5,   224,-32768,    53,-32768,-32768,    19,-32768,
    27,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    31,-32768,
-32768,   215,   129,   272,-32768,    -2,     0,-32768,   283,   259,
-32768,-32768,   310,   318,     9,   280,   280,   280,   155,-32768,
    57,-32768,   148,-32768,   139,-32768,    90,    96,-32768,   280,
   280,   280,   280,   280,   280,   280,   280,   123,-32768,   101,
   280,   280,   118,-32768,-32768,   280,   280,   104,-32768,   105,
-32768,   280,   280,   280,   280,   171,-32768,   107,-32768,    56,
    60,   280,   280,   280,   280,   280,    65,    68,    89,-32768,
   126,-32768,-32768,   280,   280,   280,   280,   280,   280,   280,
   280,   280,   280,    80,-32768,   128,-32768,-32768,   280,   280,
   280,   280,   280,   280,   156,-32768,   131,-32768,-32768,   280,
    21,-32768,   140,-32768,-32768,-32768,-32768,-32768,   143,   146,
   153,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   114,   117,    98,   113,-32768,   120,   121,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
     7,-32768,-32768,-32768,   183,   193,     7,-32768,-32768,-32768,
-32768,     7,-32768,-32768,-32768,-32768,-32768,-32768,-32768,     7,
-32768,-32768,-32768,-32768,   141,-32768,-32768,-32768,-32768,-32768,
   145,   227,     7,-32768,-32768,-32768,-32768,-32768,   138,     3,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,     7,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,     7,-32768,
-32768,-32768,-32768,     7,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   125,   216,   204,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   142,-32768,   141,-32768,-32768,
   169,   169,    93,-32768,   235,-32768,   280,-32768,   280,-32768,
-32768,-32768,-32768,-32768,   181,   154,-32768,   189,-32768,-32768,
-32768,   191,-32768,    48,   192,   200,-32768,   -21,-32768,-32768,
   194,-32768,     7,-32768,-32768,-32768,-32768,-32768,   196,   252,
   212,-32768,-32768,-32768,   210,     5,-32768,   254,   220,-32768,
-32768,-32768,   221,   275,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   279,-32768,-32768,   229,-32768,   189,-32768,-32768,     6,
-32768,   232,-32768,-32768,-32768,-32768,-32768,   220,   284,-32768,
-32768,   289,   292,-32768
};

static const short ccpgoto[] = {-32768,
-32768,   285,-32768,-32768,-32768,   226,-32768,  -149,-32768,-32768,
-32768,   184,-32768,-32768,-32768,-32768,   177,-32768,-32768,-32768,
   225,-32768,-32768,-32768,   249,-32768,-32768,-32768,-32768,    29,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    72,-32768,    44,
-32768,-32768,-32768,    -4,-32768,-32768,-32768,    64,-32768,    62,
-32768,   228,-32768,-32768,-32768,    66,-32768,   -46,   -39,-32768,
    59,-32768,-32768,   281,-32768,-32768,   261,-32768,    -6,-32768,
-32768,-32768,   209,-32768,-32768,-32768,   262,-32768
};


#define	YYLAST		354


static const short cctable[] = {   139,
   140,   141,    75,   268,   128,  -158,    71,   326,   337,   248,
    38,   129,    39,   163,   164,   165,   166,   167,   168,   169,
   170,   234,    31,   129,   175,   176,    32,   253,    76,   180,
   181,    77,   254,   317,   318,   186,   187,   188,   189,   130,
   255,    33,    34,    35,    36,   196,   197,   198,   199,   200,
    37,   130,   310,   266,    40,    42,    72,   207,   208,   144,
   212,   213,   214,   215,   216,   217,   218,   249,   269,   270,
   327,   338,   223,   224,   225,   226,   227,   228,    43,   271,
   219,   235,   103,   233,   272,   128,    44,   104,   105,   203,
    45,    89,   161,   293,   106,   260,   261,   311,   162,   262,
   107,    90,   312,   174,   182,    91,    75,   185,   108,   193,
   109,   110,   194,   111,   112,   113,   195,    92,   177,    93,
    94,   201,    95,   171,    96,    59,    71,   202,   206,    51,
   222,    52,    76,   232,    53,    77,    97,    98,   273,    51,
   220,    52,   237,   321,    53,   238,    60,    61,   239,   204,
    62,    63,   145,   294,   301,   240,   229,   243,   118,    64,
    65,    66,    67,   119,   183,   146,   241,   273,   274,   242,
   106,   190,    54,    81,   245,   275,    72,   247,   178,   246,
    46,    47,    54,   172,   120,   251,   121,   122,   147,   123,
   148,   124,    82,    83,   149,   252,   256,   274,   259,   159,
   150,    84,   281,    85,   275,   267,   281,    48,   288,   282,
   151,   152,   153,   282,   302,   142,   230,     1,   283,     2,
   297,     3,   283,    -1,     1,   290,     2,     4,     3,   260,
   261,   191,     5,   262,     4,     6,     7,   296,   300,     5,
    46,    47,     6,     7,   284,   305,     8,   308,   284,   314,
   320,   285,   322,     8,   323,   285,   328,     9,    10,    11,
   315,    89,    12,    13,     9,    10,    11,    48,   150,    12,
    13,    90,   324,   325,    59,    91,   329,   333,   279,   152,
   153,   334,   332,   335,   339,    81,   341,    92,   343,    93,
    94,   344,    95,   173,    96,    60,    61,   221,    41,    62,
    63,   231,   184,   160,    82,    83,    97,    98,    64,    65,
    66,    67,   103,    84,   316,    85,   280,   104,   105,   304,
   118,   289,   336,   292,   106,   119,   205,   298,   295,   143,
   107,   340,   106,   179,   134,   135,   136,   137,   108,   236,
   109,   110,   138,   111,   112,   113,   120,   192,   121,   122,
     0,   123,     0,   124
};

static const short cccheck[] = {    46,
    47,    48,     3,     1,    44,     3,     9,     3,     3,     3,
    58,     3,    60,    60,    61,    62,    63,    64,    65,    66,
    67,     1,     3,     3,    71,    72,    60,   177,    29,    76,
    77,    32,   182,    55,    56,    82,    83,    84,    85,    31,
   190,    60,    60,    58,    60,    92,    93,    94,    95,    96,
    60,    31,     5,   203,    60,     3,    59,   104,   105,     3,
   107,   108,   109,   110,   111,   112,   113,    61,    66,   219,
    66,    66,   119,   120,   121,   122,   123,   124,    60,   229,
     1,    61,     3,   130,   234,   125,    60,     8,     9,     1,
    60,     3,     3,     1,    15,     3,     4,    50,     3,     7,
    21,    13,    55,     3,     1,    17,     3,     3,    29,     3,
    31,    32,    57,    34,    35,    36,    57,    29,     1,    31,
    32,    57,    34,     1,    36,     3,     9,    60,     3,     1,
     3,     3,    29,     3,     6,    32,    48,    49,    14,     1,
    61,     3,     3,   293,     6,     3,    24,    25,     3,    61,
    28,    29,     5,    61,     1,     3,     1,    60,     3,    37,
    38,    39,    40,     8,    61,    18,    53,    14,    44,    53,
    15,     1,    44,     3,    62,    51,    59,    57,    61,    60,
    26,    27,    44,    61,    29,     3,    31,    32,    41,    34,
    43,    36,    22,    23,    47,     3,    56,    44,    54,    61,
    53,    31,     3,    33,    51,    68,     3,    53,    67,    10,
    63,    64,    65,    10,    61,    61,    61,     1,    19,     3,
   267,     5,    19,     0,     1,    57,     3,    11,     5,     3,
     4,    61,    16,     7,    11,    19,    20,     3,    58,    16,
    26,    27,    19,    20,    45,    57,    30,    57,    45,    58,
    57,    52,    57,    30,     3,    52,     3,    41,    42,    43,
    61,     3,    46,    47,    41,    42,    43,    53,    53,    46,
    47,    13,    61,    64,     3,    17,    57,     3,    63,    64,
    65,     3,    62,    55,    53,     3,     3,    29,     0,    31,
    32,     0,    34,    68,    36,    24,    25,   114,    14,    28,
    29,   125,    78,    55,    22,    23,    48,    49,    37,    38,
    39,    40,     3,    31,   286,    33,   245,     8,     9,   276,
     3,   258,   327,   262,    15,     8,    99,   269,   263,    49,
    21,   338,    15,    73,    55,    56,    57,    58,    29,   131,
    31,    32,    63,    34,    35,    36,    29,    86,    31,    32,
    -1,    34,    -1,    36
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.27.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define ccerrok		(ccerrstatus = 0)
#define ccclearin	(ccchar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto ccacceptlab
#define YYABORT 	goto ccabortlab
#define YYERROR		goto ccerrlab1
/* Like YYERROR except do call ccerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto ccerrlab
#define YYRECOVERING()  (!!ccerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (ccchar == YYEMPTY && cclen == 1)				\
    { ccchar = (token), cclval = (value);			\
      ccchar1 = YYTRANSLATE (ccchar);				\
      YYPOPSTACK;						\
      goto ccbackup;						\
    }								\
  else								\
    { ccerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		cclex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		cclex(&cclval, &cclloc, YYLEX_PARAM)
#else
#define YYLEX		cclex(&cclval, &cclloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		cclex(&cclval, YYLEX_PARAM)
#else
#define YYLEX		cclex(&cclval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	ccchar;			/*  the lookahead symbol		*/
YYSTYPE	cclval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE cclloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int ccnerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int ccdebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __cc_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __cc_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__cc_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__cc_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 216 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into ccparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int ccparse (void *);
#else
int ccparse (void);
#endif
#endif

int
ccparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int ccstate;
  register int ccn;
  register short *ccssp;
  register YYSTYPE *ccvsp;
  int ccerrstatus;	/*  number of tokens to shift before error messages enabled */
  int ccchar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	ccssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE ccvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *ccss = ccssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *ccvs = ccvsa;	/*  to allow ccoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE cclsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *ccls = cclsa;
  YYLTYPE *cclsp;

#define YYPOPSTACK   (ccvsp--, ccssp--, cclsp--)
#else
#define YYPOPSTACK   (ccvsp--, ccssp--)
#endif

  int ccstacksize = YYINITDEPTH;
  int ccfree_stacks = 0;

#ifdef YYPURE
  int ccchar;
  YYSTYPE cclval;
  int ccnerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE cclloc;
#endif
#endif

  YYSTYPE ccval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int cclen;

#if YYDEBUG != 0
  if (ccdebug)
    fprintf(stderr, "Starting parse\n");
#endif

  ccstate = 0;
  ccerrstatus = 0;
  ccnerrs = 0;
  ccchar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  ccssp = ccss - 1;
  ccvsp = ccvs;
#ifdef YYLSP_NEEDED
  cclsp = ccls;
#endif

/* Push a new state, which is found in  ccstate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
ccnewstate:

  *++ccssp = ccstate;

  if (ccssp >= ccss + ccstacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *ccvs1 = ccvs;
      short *ccss1 = ccss;
#ifdef YYLSP_NEEDED
      YYLTYPE *ccls1 = ccls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = ccssp - ccss + 1;

#ifdef ccoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if ccoverflow is a macro.  */
      ccoverflow("parser stack overflow",
		 &ccss1, size * sizeof (*ccssp),
		 &ccvs1, size * sizeof (*ccvsp),
		 &ccls1, size * sizeof (*cclsp),
		 &ccstacksize);
#else
      ccoverflow("parser stack overflow",
		 &ccss1, size * sizeof (*ccssp),
		 &ccvs1, size * sizeof (*ccvsp),
		 &ccstacksize);
#endif

      ccss = ccss1; ccvs = ccvs1;
#ifdef YYLSP_NEEDED
      ccls = ccls1;
#endif
#else /* no ccoverflow */
      /* Extend the stack our own way.  */
      if (ccstacksize >= YYMAXDEPTH)
	{
	  ccerror("parser stack overflow");
	  if (ccfree_stacks)
	    {
	      free (ccss);
	      free (ccvs);
#ifdef YYLSP_NEEDED
	      free (ccls);
#endif
	    }
	  return 2;
	}
      ccstacksize *= 2;
      if (ccstacksize > YYMAXDEPTH)
	ccstacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      ccfree_stacks = 1;
#endif
      ccss = (short *) YYSTACK_ALLOC (ccstacksize * sizeof (*ccssp));
      __cc_memcpy ((char *)ccss, (char *)ccss1,
		   size * (unsigned int) sizeof (*ccssp));
      ccvs = (YYSTYPE *) YYSTACK_ALLOC (ccstacksize * sizeof (*ccvsp));
      __cc_memcpy ((char *)ccvs, (char *)ccvs1,
		   size * (unsigned int) sizeof (*ccvsp));
#ifdef YYLSP_NEEDED
      ccls = (YYLTYPE *) YYSTACK_ALLOC (ccstacksize * sizeof (*cclsp));
      __cc_memcpy ((char *)ccls, (char *)ccls1,
		   size * (unsigned int) sizeof (*cclsp));
#endif
#endif /* no ccoverflow */

      ccssp = ccss + size - 1;
      ccvsp = ccvs + size - 1;
#ifdef YYLSP_NEEDED
      cclsp = ccls + size - 1;
#endif

#if YYDEBUG != 0
      if (ccdebug)
	fprintf(stderr, "Stack size increased to %d\n", ccstacksize);
#endif

      if (ccssp >= ccss + ccstacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (ccdebug)
    fprintf(stderr, "Entering state %d\n", ccstate);
#endif

  goto ccbackup;
 ccbackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* ccresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  ccn = ccpact[ccstate];
  if (ccn == YYFLAG)
    goto ccdefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* ccchar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (ccchar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (ccdebug)
	fprintf(stderr, "Reading a token: ");
#endif
      ccchar = YYLEX;
    }

  /* Convert token to internal form (in ccchar1) for indexing tables with */

  if (ccchar <= 0)		/* This means end of input. */
    {
      ccchar1 = 0;
      ccchar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (ccdebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      ccchar1 = YYTRANSLATE(ccchar);

#if YYDEBUG != 0
      if (ccdebug)
	{
	  fprintf (stderr, "Next token is %d (%s", ccchar, cctname[ccchar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, ccchar, cclval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  ccn += ccchar1;
  if (ccn < 0 || ccn > YYLAST || cccheck[ccn] != ccchar1)
    goto ccdefault;

  ccn = cctable[ccn];

  /* ccn is what to do for this token type in this state.
     Negative => reduce, -ccn is rule number.
     Positive => shift, ccn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (ccn < 0)
    {
      if (ccn == YYFLAG)
	goto ccerrlab;
      ccn = -ccn;
      goto ccreduce;
    }
  else if (ccn == 0)
    goto ccerrlab;

  if (ccn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (ccdebug)
    fprintf(stderr, "Shifting token %d (%s), ", ccchar, cctname[ccchar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (ccchar != YYEOF)
    ccchar = YYEMPTY;

  *++ccvsp = cclval;
#ifdef YYLSP_NEEDED
  *++cclsp = cclloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (ccerrstatus) ccerrstatus--;

  ccstate = ccn;
  goto ccnewstate;

/* Do the default action for the current state.  */
ccdefault:

  ccn = ccdefact[ccstate];
  if (ccn == 0)
    goto ccerrlab;

/* Do a reduction.  ccn is the number of a rule to reduce with.  */
ccreduce:
  cclen = ccr2[ccn];
  if (cclen > 0)
    ccval = ccvsp[1-cclen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (ccdebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       ccn, ccrline[ccn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = ccprhs[ccn]; ccrhs[i] > 0; i++)
	fprintf (stderr, "%s ", cctname[ccrhs[i]]);
      fprintf (stderr, " -> %s\n", cctname[ccr1[ccn]]);
    }
#endif


  switch (ccn) {

case 6:
#line 193 "config.y"
{
			  expect_string = 0;
			  ccclearin; ccerrok;
		  ;
    break;}
case 21:
#line 219 "config.y"
{
			  ccclearin; ccerrok;
		  ;
    break;}
case 24:
#line 228 "config.y"
{
			  asgn(&myip, &ccvsp[0].value, AT_IPADDR, 0);
		  ;
    break;}
case 25:
#line 232 "config.y"
{
			  asgn(&config.delayed_hup_wait, &ccvsp[0].value, AT_INT, 0);
		  ;
    break;}
case 26:
#line 236 "config.y"
{
			  asgn(&config.max_requests, &ccvsp[0].value, AT_INT, 0);
		  ;
    break;}
case 27:
#line 240 "config.y"
{
			  asgn(&radlog_dir, &ccvsp[0].value, AT_STRING, 1);
		  ;
    break;}
case 28:
#line 244 "config.y"
{
			  asgn(&radacct_dir, &ccvsp[0].value, AT_STRING, 1);
		  ;
    break;}
case 29:
#line 248 "config.y"
{
			  asgn(&config.exec_user, &ccvsp[0].value, AT_STRING, 0);
		  ;
    break;}
case 30:
#line 252 "config.y"
{
			  radlog(L_WARN,
				 _("%s:%d: exec-program-group is obsolete:"),
				 filename, line_num);
		  ;
    break;}
case 31:
#line 258 "config.y"
{
			  asgn(&username_valid_chars, &ccvsp[0].value, AT_STRING, 0);
		  ;
    break;}
case 33:
#line 265 "config.y"
{
			  putback("}", 1);
		  ;
    break;}
case 34:
#line 272 "config.y"
{
			  if (!got_listen)
				  listen_auth(NULL);
		  ;
    break;}
case 35:
#line 279 "config.y"
{
			  got_listen = 0;
		  ;
    break;}
case 38:
#line 287 "config.y"
{
			  ccclearin; ccerrok;
		  ;
    break;}
case 41:
#line 297 "config.y"
{
			  got_listen = 1;
			  listen_auth(ccvsp[0].hostlist.head);
			  free_slist((struct slist*)ccvsp[0].hostlist.head, NULL);
		  ;
    break;}
case 42:
#line 303 "config.y"
{
			  asgn(&auth_port, &ccvsp[0].value, AT_PORT, 0);
		  ;
    break;}
case 43:
#line 307 "config.y"
{
			  asgn(&request_class[R_AUTH].spawn, &ccvsp[0].value, AT_BOOL, 0);
		  ;
    break;}
case 44:
#line 311 "config.y"
{
			  asgn(&request_class[R_AUTH].ttl, &ccvsp[0].value, AT_INT, 0);
		  ;
    break;}
case 45:
#line 315 "config.y"
{
			  asgn(&request_class[R_AUTH].max_requests, &ccvsp[0].value,
			       AT_INT, 0);
		  ;
    break;}
case 46:
#line 320 "config.y"
{
			  asgn(&request_class[R_AUTH].cleanup_delay, &ccvsp[0].value,
			       AT_INT, 0);
		  ;
    break;}
case 47:
#line 325 "config.y"
{
			  asgn(&auth_detail, &ccvsp[0].value, AT_BOOL, 0);
		  ;
    break;}
case 48:
#line 329 "config.y"
{
			  asgn(&strip_names, &ccvsp[0].value, AT_BOOL, 0);
		  ;
    break;}
case 49:
#line 333 "config.y"
{
			  asgn(&config.checkrad_assume_logged, &ccvsp[0].value,
			       AT_BOOL, 0);
		  ;
    break;}
case 50:
#line 338 "config.y"
{
			  asgn(&warning_seconds, &ccvsp[0].value, AT_INT, 0);
		  ;
    break;}
case 51:
#line 345 "config.y"
{
			  if (!got_listen)
				  listen_acct(NULL);
		  ;
    break;}
case 52:
#line 352 "config.y"
{
			  got_listen = 0;
		  ;
    break;}
case 55:
#line 360 "config.y"
{
			  ccclearin; ccerrok;
		  ;
    break;}
case 58:
#line 370 "config.y"
{
			  got_listen = 1;
			  listen_acct(ccvsp[0].hostlist.head);
			  free_slist((struct slist*)ccvsp[0].hostlist.head, NULL);
		  ;
    break;}
case 59:
#line 376 "config.y"
{
			  asgn(&acct_port, &ccvsp[0].value, AT_PORT, 0);
		  ;
    break;}
case 60:
#line 380 "config.y"
{
			  asgn(&request_class[R_ACCT].spawn, &ccvsp[0].value, AT_BOOL, 0);
		  ;
    break;}
case 61:
#line 384 "config.y"
{
			  asgn(&request_class[R_ACCT].ttl, &ccvsp[0].value, AT_INT, 0);
		  ;
    break;}
case 62:
#line 388 "config.y"
{
			  asgn(&request_class[R_ACCT].max_requests, &ccvsp[0].value,
			       AT_INT, 0);
		  ;
    break;}
case 63:
#line 393 "config.y"
{
			  asgn(&request_class[R_ACCT].cleanup_delay, &ccvsp[0].value,
			       AT_INT, 0);
		  ;
    break;}
case 64:
#line 398 "config.y"
{
			  asgn(&acct_detail, &ccvsp[0].value, AT_BOOL, 0);
		  ;
    break;}
case 68:
#line 411 "config.y"
{
			  ccclearin; ccerrok;
		  ;
    break;}
case 71:
#line 421 "config.y"
{
			  asgn(&request_class[R_PROXY].max_requests, &ccvsp[0].value,
			       AT_INT, 0);
		  ;
    break;}
case 72:
#line 426 "config.y"
{
			  asgn(&request_class[R_PROXY].cleanup_delay, &ccvsp[0].value,
			       AT_INT, 0);
		  ;
    break;}
case 79:
#line 445 "config.y"
{
			  expect_string = 0;
			  in_category = 0;
			  ccclearin;
			  ccerrok;
		  ;
    break;}
case 80:
#line 456 "config.y"
{
			  if (channel.mode == LM_UNKNOWN) {
				  radlog(L_ERR,
				      _("%s:%d: no channel mode for `%s'"), 
				      	filename, line_num, ccvsp[-3].string);
			  } else {
				  channel.name = ccvsp[-3].string;
				  register_channel(&channel);
				  if (channel.mode == LM_FILE)
					  efree(channel.id.file);
			  }
                  ;
    break;}
case 81:
#line 470 "config.y"
{ expect_string = 1; ;
    break;}
case 82:
#line 471 "config.y"
{
			  expect_string = 0;
			  channel.mode = LM_UNKNOWN;
			  strcpy(ccval.string, ccvsp[0].string);
		  ;
    break;}
case 86:
#line 484 "config.y"
{
			  channel.mode = LM_FILE;
			  channel.id.file = estrdup(ccvsp[-1].string);
		  ;
    break;}
case 87:
#line 489 "config.y"
{
			  channel.mode = LM_SYSLOG;
			  channel.id.prio = ccvsp[-3].number | syslog_severity[ccvsp[-1].number] ;
                  ;
    break;}
case 88:
#line 494 "config.y"
{
			  if (ccvsp[-1].bool)
				  channel.options |= ccvsp[-2].number;
			  else
				  channel.options &= ~ccvsp[-2].number;
		  ;
    break;}
case 89:
#line 500 "config.y"
{ expect_string=1; ;
    break;}
case 90:
#line 501 "config.y"
{
			  expect_string = 0;
			  radlog(L_WARN,
				 _("%s:%d: option statement is obsolete"),
				 filename, line_num);
			  channel.options |= ccvsp[-1].number;
		  ;
    break;}
case 92:
#line 512 "config.y"
{
			  ccval.number = LOG_AUTH;
		  ;
    break;}
case 94:
#line 522 "config.y"
{
			  switch (ccvsp[-3].category_name.cat) {
			  case L_AUTH:
				  log_mode = cat_def.level;
				  break;
			  default:
				  if (cat_def.level)
					  radlog(L_WARN,
			   _("%s:%d: no levels applicable for this category"),
						 filename, line_num);

			  }
			  in_category = 0;
			  register_category(ccvsp[-3].category_name.cat, ccvsp[-3].category_name.pri, cat_def.head);
			  free_chanlist(cat_def.head);
		  ;
    break;}
case 95:
#line 541 "config.y"
{
			  cat_def.level = 0;
			  cat_def.head = cat_def.tail = NULL;
		  ;
    break;}
case 97:
#line 551 "config.y"
{
			  in_category = ccvsp[0].number;
			  ccval.category_name.cat = ccvsp[0].number;
			  ccval.category_name.pri = -1;
		  ;
    break;}
case 98:
#line 557 "config.y"
{
			  in_category = ccvsp[0].number;
			  ccval.category_name.cat = -1;
			  ccval.category_name.pri = ccvsp[0].number;
		  ;
    break;}
case 99:
#line 563 "config.y"
{
			  in_category = ccvsp[-2].number|ccvsp[0].number;
			  ccval.category_name.cat = ccvsp[-2].number;
			  ccval.category_name.pri = ccvsp[0].number;
		  ;
    break;}
case 100:
#line 569 "config.y"
{
			  in_category = ccvsp[-2].number;
			  ccval.category_name.cat = ccvsp[-2].number;
			  ccval.category_name.pri = -1;
		  ;
    break;}
case 101:
#line 577 "config.y"
{
			  ccval.number = L_ACCT;
		  ;
    break;}
case 102:
#line 581 "config.y"
{
			  ccval.number = L_AUTH;
		  ;
    break;}
case 103:
#line 585 "config.y"
{
			  ccval.number = L_ACCT;
		  ;
    break;}
case 104:
#line 589 "config.y"
{
			  ccval.number = L_SNMP;
		  ;
    break;}
case 105:
#line 593 "config.y"
{
			  ccval.number = L_PROXY;
		  ;
    break;}
case 106:
#line 597 "config.y"
{
			  ccval.number = -1;
		  ;
    break;}
case 107:
#line 603 "config.y"
{
			  ccval.number = L_UPTO(ccvsp[0].number);
		  ;
    break;}
case 108:
#line 607 "config.y"
{
			  ccval.number = L_MASK(ccvsp[0].number);
		  ;
    break;}
case 109:
#line 611 "config.y"
{
			  ccval.number = L_UPTO(L_DEBUG) & ~L_MASK(ccvsp[0].number);
		  ;
    break;}
case 112:
#line 619 "config.y"
{
			  /*free_chanlist?*/
			  expect_string = 0;
			  putback("}", 1);
			  ccclearin;
                          ccerrok;  
                  ;
    break;}
case 113:
#line 628 "config.y"
{ expect_string = 1; ;
    break;}
case 114:
#line 629 "config.y"
{
			  Channel *channel = channel_lookup(ccvsp[-1].string);
			  expect_string = 0;
			  if (!channel) {
				  radlog(L_ERR,
					 _("%s:%d: channel `%s' not defined"),
					 filename, line_num, ccvsp[-1].string);
			  } else {
				  Chanlist *chanlist = make_chanlist(channel);
				  if (cat_def.tail)
					  cat_def.tail->next = chanlist;
				  else
					  cat_def.head = chanlist;
				  cat_def.tail = chanlist;
			  }
		  ;
    break;}
case 115:
#line 646 "config.y"
{
			  if (ccvsp[-1].bool)
				  cat_def.level |= ccvsp[-2].number;
			  else
				  cat_def.level &= ~ccvsp[-2].number;
		  ;
    break;}
case 116:
#line 653 "config.y"
{
			  expect_string = 0;
			  if ((in_category & L_CATMASK) == L_AUTH) 
				  cat_def.level |= ccvsp[-1].number;
		  ;
    break;}
case 117:
#line 661 "config.y"
{
			  if (in_category & L_MASK(L_DEBUG)) {
				  expect_string = 1;
				  clear_debug();
			  } else if ((in_category & L_CATMASK) == L_AUTH) {
				  expect_string = 1;
				  radlog(L_WARN,
			      _("%s:%d: auth:level statement is obsolete"),
					 filename, line_num);
			  }
		  ;
    break;}
case 119:
#line 676 "config.y"
{
			  ccval.number = ccvsp[-2].number | ccvsp[0].number;
		  ;
    break;}
case 120:
#line 682 "config.y"
{
			  if (in_category & L_MASK(L_DEBUG)) {
				  if (set_module_debug_level(ccvsp[0].string, -1))
					  radlog(L_WARN,
					 _("%s:%d: no such module name: %s"),
						 filename, line_num, ccvsp[0].string);
				  ccval.number = 0;
			  } else if (in_category & L_AUTH) {
				  /* Backward compatibility */
				  if (strcmp(ccvsp[0].string, "auth") == 0)
					  ccval.number = RLOG_AUTH;
				  else if (strcmp(ccvsp[0].string, "pass") == 0)
					  ccval.number = RLOG_AUTH_PASS;
				  else if (strcmp(ccvsp[0].string, "failed_pass") == 0)
					  ccval.number = RLOG_FAILED_PASS;
				  else {
					  radlog(L_WARN,
					 _("%s:%d: invalid level: %s"),
						 filename, line_num, ccvsp[0].string);
					  ccval.number = 0;
				  }
			  } else {
				  ccerror("level syntax");
				  YYERROR;
			  }
		  ;
    break;}
case 121:
#line 709 "config.y"
{
			  if (!(in_category & L_MASK(L_DEBUG))) {
				  ccerror("level syntax");
				  YYERROR;
			  }
			  if (set_module_debug_level(ccvsp[-2].string, ccvsp[0].number))
				  radlog(L_WARN,
					 _("%s:%d: no such module name: %s"),
					 filename, line_num, ccvsp[-2].string);
		  ;
    break;}
case 122:
#line 723 "config.y"
{
#ifdef USE_DBM
			  use_dbm = ccvsp[0].bool;
			  if (debug_config)
				  radlog(L_DEBUG, _("use dbm: %d"), use_dbm);
#else
			  radlog(L_WARN,
				 _("%s:%d: usedbm statement ignored: radiusd compiled without DBM support"),
				 filename, line_num);
#endif
		  ;
    break;}
case 123:
#line 739 "config.y"
{
#ifndef USE_SNMP
			  radlog(L_WARN,
				 _("%s:%d: snmp statement ignored: radiusd compiled without snmp support"),
				 filename, line_num);
#endif
		  ;
    break;}
case 125:
#line 750 "config.y"
{
			  if (ccvsp[0].number > 32) {
				  radlog(L_ERR, _("invalid netmask: %d"), ccvsp[0].number);
				  YYERROR;
			  }
			  ccval.ipaddr = (0xfffffffful >> (32-ccvsp[0].number)) << (32-ccvsp[0].number);
		  ;
    break;}
case 126:
#line 760 "config.y"
{
#ifdef USE_SNMP
			  ACL *p = alloc_entry(sizeof(*p));

			  p->ipaddr = htonl(ccvsp[-2].ipaddr);
			  p->netmask = htonl(ccvsp[0].ipaddr);
			  ccval.acl = p;
#endif
		  ;
    break;}
case 127:
#line 770 "config.y"
{
#ifdef USE_SNMP
			  ACL *p = alloc_entry(sizeof(*p));

			  p->ipaddr = htonl(ccvsp[0].ipaddr);
			  p->netmask = 0xfffffffful;
			  ccval.acl = p;
#endif
		  ;
    break;}
case 128:
#line 782 "config.y"
{
#ifdef USE_SNMP
			  ccval.netlist.head = ccval.netlist.tail = ccvsp[0].acl;
#endif
		  ;
    break;}
case 129:
#line 788 "config.y"
{
#ifdef USE_SNMP
			  ccvsp[-1].netlist.tail->next = ccvsp[0].acl;
			  ccvsp[-1].netlist.tail = ccvsp[0].acl;
			  ccval.netlist = ccvsp[-1].netlist;
#endif
		  ;
    break;}
case 130:
#line 798 "config.y"
{
#ifdef USE_SNMP
			  if ((ccval.acl = find_netlist(ccvsp[0].string)) == NULL) {
				  radlog(L_ERR, _("%s:%d: no such acl: %s"),
				      filename, line_num, ccvsp[0].string);
				  YYERROR;
			  }
#else
			  ccval.acl = 0;
#endif
		  ;
    break;}
case 133:
#line 814 "config.y"
{
			 ccclearin;
			 ccerrok;
		  ;
    break;}
case 136:
#line 825 "config.y"
{
#ifdef USE_SNMP
                          if (server_id)
			         efree(server_id);
                          server_id = ident_string(ccvsp[0].string);
#endif
                  ;
    break;}
case 137:
#line 833 "config.y"
{
#ifdef USE_SNMP
			  asgn(&snmp_port, &ccvsp[0].value, AT_PORT, 0);
#endif
		  ;
    break;}
case 138:
#line 839 "config.y"
{
#ifdef USE_SNMP
			  asgn(&request_class[R_SNMP].spawn, &ccvsp[0].value, AT_BOOL, 0);
#endif
		  ;
    break;}
case 139:
#line 845 "config.y"
{
#ifdef USE_SNMP
			  asgn(&request_class[R_SNMP].ttl, &ccvsp[0].value, AT_INT, 0);
#endif
		  ;
    break;}
case 140:
#line 851 "config.y"
{
#ifdef USE_SNMP
			  asgn(&request_class[R_SNMP].max_requests, &ccvsp[0].value,
			       AT_INT, 0);
#endif
		  ;
    break;}
case 141:
#line 858 "config.y"
{
#ifdef USE_SNMP
			  asgn(&request_class[R_SNMP].cleanup_delay, &ccvsp[0].value,
			       AT_INT, 0);
#endif
		  ;
    break;}
case 142:
#line 865 "config.y"
{
#ifdef USE_SNMP
			  if (snmp_find_community(ccvsp[-1].string)) {
				  radlog(L_ERR,
				      _("%s:%d: community %s already declared"),
				      filename, line_num, ccvsp[-1].string);
			  } else {
				  snmp_add_community(ccvsp[-1].string, ccvsp[0].number);
			  }
#endif
		  ;
    break;}
case 143:
#line 877 "config.y"
{
#ifdef USE_SNMP
			  add_netlist(ccvsp[-1].string, ccvsp[0].netlist.head);
#endif
		  ;
    break;}
case 148:
#line 891 "config.y"
{
			 ccclearin;
			 ccerrok;
		  ;
    break;}
case 151:
#line 902 "config.y"
{
#ifdef USE_SNMP
			  Community *comm = snmp_find_community(ccvsp[0].string);
			  if (!comm) {
				  radlog(L_ERR, 
                                      _("%s:%d: undefined community %s"),
				      filename, line_num, ccvsp[-1].acl);
			  } else
				  snmp_add_acl(ccvsp[-1].acl, comm);
#endif
		  ;
    break;}
case 152:
#line 914 "config.y"
{
#ifdef USE_SNMP
			  snmp_add_acl(ccvsp[0].acl, NULL);
#endif
		  ;
    break;}
case 153:
#line 924 "config.y"
{
			  ccval.value.type = AT_STRING;
			  strncpy(ccval.value.v.string, ccvsp[0].string, sizeof(ccval.value.v.string));
			  ccval.value.v.string[sizeof(ccval.value.v.string)-1] = 0;
		  ;
    break;}
case 154:
#line 930 "config.y"
{
			  ccval.value.type = AT_IPADDR;
			  ccval.value.v.ipaddr = ccvsp[0].ipaddr;
		  ;
    break;}
case 155:
#line 935 "config.y"
{
			  ccval.value.type = AT_IPADDR;
			  ccval.value.v.ipaddr = INADDR_ANY;
		  ;
    break;}
case 156:
#line 940 "config.y"
{
			  ccval.value.type = AT_BOOL;
			  ccval.value.v.bool = ccvsp[0].bool;
		  ;
    break;}
case 157:
#line 945 "config.y"
{
			  ccval.value.type = AT_INT;
			  ccval.value.v.number = ccvsp[0].number;
		  ;
    break;}
case 158:
#line 952 "config.y"
{
			  ccval.hostlist = ccvsp[0].hostlist;
		  ;
    break;}
case 159:
#line 956 "config.y"
{
			  free_slist((struct slist*)ccvsp[-1].hostlist.head, NULL);
			  ccclearin; ccerrok;
			  ccval.hostlist.head = NULL;
		  ;
    break;}
case 160:
#line 964 "config.y"
{
			  ccval.hostlist.head = alloc_entry(sizeof(*ccval.hostlist.head));
			  ccval.hostlist.head->ipaddr = ccvsp[0].hostdecl.ipaddr;
			  ccval.hostlist.head->port = ccvsp[0].hostdecl.port;
			  ccval.hostlist.head->next = NULL;
			  ccval.hostlist.tail = ccval.hostlist.head;
		  ;
    break;}
case 161:
#line 972 "config.y"
{
			  HOSTDECL *hp = alloc_entry(sizeof(*hp));
			  hp->ipaddr = ccvsp[0].hostdecl.ipaddr;
			  hp->port = ccvsp[0].hostdecl.port;
			  hp->next = NULL;
			  ccval.hostlist.tail->next = hp;
			  ccval.hostlist.tail = hp;
		  ;
    break;}
case 162:
#line 983 "config.y"
{
			  asgn(&ccval.hostdecl.ipaddr, &ccvsp[0].value, AT_IPADDR, 0);
			  ccval.hostdecl.port = 0;
		  ;
    break;}
case 163:
#line 988 "config.y"
{
			  asgn(&ccval.hostdecl.ipaddr, &ccvsp[-2].value, AT_IPADDR, 0);
			  asgn(&ccval.hostdecl.port, &ccvsp[0].value, AT_PORT, 0);
		  ;
    break;}
case 164:
#line 995 "config.y"
{
#ifdef USE_SERVER_GUILE
			  use_guile = 1;
#else
			  radlog(L_WARN,
				 _("%s:%d: guile statement ignored: radiusd compiled without guile support"),
				 filename, line_num);
#endif
		  ;
    break;}
case 167:
#line 1011 "config.y"
{
#ifdef USE_SERVER_GUILE
			  if (ccvsp[-1].value.type != AT_STRING) {
				  radlog(L_ERR, 
					 _("%s:%d: wrong datatype (should be string)"),
					 filename, line_num);
			  } else
				  rscm_add_load_path(ccvsp[-1].value.v.string);
#endif
		  ;
    break;}
case 168:
#line 1022 "config.y"
{
#ifdef USE_SERVER_GUILE
			  if (ccvsp[-1].value.type != AT_STRING) {
				  radlog(L_ERR, 
					 _("%s:%d: wrong datatype (should be string)"),
					 filename, line_num);
			  } else {
				  scheme_load(ccvsp[-1].value.v.string);
			  }
#endif
		  ;
    break;}
case 169:
#line 1034 "config.y"
{
			  if (ccvsp[-2].number == L_DEBUG) {
#ifdef USE_SERVER_GUILE
				  int dbg;
				  asgn(&dbg, &ccvsp[-1].value, AT_BOOL, 0);
				  scheme_debug(dbg);
#endif
			  } else {
				  ccerror("syntax error");
			  }
		  ;
    break;}
case 173:
#line 1056 "config.y"
{
			  ccclearin; ccerrok;
                  ;
    break;}
case 174:
#line 1062 "config.y"
{
			  asgn(&message_text[ccvsp[-2].number], &ccvsp[-1].value, AT_STRING, 0);
		  ;
    break;}
case 175:
#line 1066 "config.y"
{
			  asgn(&message_text[MSG_PASSWORD_EXPIRE_WARNING], &ccvsp[-1].value, AT_STRING, 0);
		  ;
    break;}
case 177:
#line 1074 "config.y"
{
			  ccval.number = ccvsp[-2].number | ccvsp[0].number;
		  ;
    break;}
case 178:
#line 1080 "config.y"
{
			  if (strcmp(ccvsp[0].string, "pid") == 0)
				  ccval.number = LO_PID;
			  else if (strcmp(ccvsp[0].string, "cons") == 0)
				  ccval.number = LO_CONS;
			  else if (strcmp(ccvsp[0].string, "level") == 0)
				  ccval.number = LO_PRI;
			  else
				  ccval.number = 0;
		  ;
    break;}
case 180:
#line 1097 "config.y"
{
			  radlog(L_WARN,
				 _("%s:%d: ignoring obsolete cntl statement"),
				 filename, line_num);
		  ;
    break;}
case 183:
#line 1107 "config.y"
{
			  ccclearin; ccerrok;
		  ;
    break;}
case 187:
#line 1120 "config.y"
{
			  radlog(L_WARN,
				_("%s:%d: ignoring obsolete notify statement"),
				 filename, line_num);
		  ;
    break;}
case 188:
#line 1126 "config.y"
{
			  radlog(L_WARN,
				_("%s:%d: ignoring obsolete notify statement"),
				 filename, line_num);
		  ;
    break;}
case 191:
#line 1136 "config.y"
{
			  ccclearin;
                          ccerrok;
		  ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 542 "/usr/share/bison.simple"

  ccvsp -= cclen;
  ccssp -= cclen;
#ifdef YYLSP_NEEDED
  cclsp -= cclen;
#endif

#if YYDEBUG != 0
  if (ccdebug)
    {
      short *ssp1 = ccss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != ccssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++ccvsp = ccval;

#ifdef YYLSP_NEEDED
  cclsp++;
  if (cclen == 0)
    {
      cclsp->first_line = cclloc.first_line;
      cclsp->first_column = cclloc.first_column;
      cclsp->last_line = (cclsp-1)->last_line;
      cclsp->last_column = (cclsp-1)->last_column;
      cclsp->text = 0;
    }
  else
    {
      cclsp->last_line = (cclsp+cclen-1)->last_line;
      cclsp->last_column = (cclsp+cclen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  ccn = ccr1[ccn];

  ccstate = ccpgoto[ccn - YYNTBASE] + *ccssp;
  if (ccstate >= 0 && ccstate <= YYLAST && cccheck[ccstate] == *ccssp)
    ccstate = cctable[ccstate];
  else
    ccstate = ccdefgoto[ccn - YYNTBASE];

  goto ccnewstate;

ccerrlab:   /* here on detecting error */

  if (! ccerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++ccnerrs;

#ifdef YYERROR_VERBOSE
      ccn = ccpact[ccstate];

      if (ccn > YYFLAG && ccn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -ccn if nec to avoid negative indexes in cccheck.  */
	  for (x = (ccn < 0 ? -ccn : 0);
	       x < (sizeof(cctname) / sizeof(char *)); x++)
	    if (cccheck[x + ccn] == x)
	      size += strlen(cctname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (ccn < 0 ? -ccn : 0);
		       x < (sizeof(cctname) / sizeof(char *)); x++)
		    if (cccheck[x + ccn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, cctname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      ccerror(msg);
	      free(msg);
	    }
	  else
	    ccerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	ccerror("parse error");
    }

  goto ccerrlab1;
ccerrlab1:   /* here on error raised explicitly by an action */

  if (ccerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (ccchar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (ccdebug)
	fprintf(stderr, "Discarding token %d (%s).\n", ccchar, cctname[ccchar1]);
#endif

      ccchar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  ccerrstatus = 3;		/* Each real token shifted decrements this */

  goto ccerrhandle;

ccerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  ccn = ccdefact[ccstate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (ccn) goto ccdefault;
#endif

ccerrpop:   /* pop the current state because it cannot handle the error token */

  if (ccssp == ccss) YYABORT;
  ccvsp--;
  ccstate = *--ccssp;
#ifdef YYLSP_NEEDED
  cclsp--;
#endif

#if YYDEBUG != 0
  if (ccdebug)
    {
      short *ssp1 = ccss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != ccssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

ccerrhandle:

  ccn = ccpact[ccstate];
  if (ccn == YYFLAG)
    goto ccerrdefault;

  ccn += YYTERROR;
  if (ccn < 0 || ccn > YYLAST || cccheck[ccn] != YYTERROR)
    goto ccerrdefault;

  ccn = cctable[ccn];
  if (ccn < 0)
    {
      if (ccn == YYFLAG)
	goto ccerrpop;
      ccn = -ccn;
      goto ccreduce;
    }
  else if (ccn == 0)
    goto ccerrpop;

  if (ccn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (ccdebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++ccvsp = cclval;
#ifdef YYLSP_NEEDED
  *++cclsp = cclloc;
#endif

  ccstate = ccn;
  goto ccnewstate;

 ccacceptlab:
  /* YYACCEPT comes here.  */
  if (ccfree_stacks)
    {
      free (ccss);
      free (ccvs);
#ifdef YYLSP_NEEDED
      free (ccls);
#endif
    }
  return 0;

 ccabortlab:
  /* YYABORT comes here.  */
  if (ccfree_stacks)
    {
      free (ccss);
      free (ccvs);
#ifdef YYLSP_NEEDED
      free (ccls);
#endif
    }
  return 1;
}
#line 1152 "config.y"

	   
int
cclex()
{
again:
	skipws();

	if (*curp == '#') { 
		skipline();
		goto again;
	} 
	if (*curp == '/' && curp[1] == '*') {
		int keep_line = line_num;

		curp += 2;
		do {
			while (*curp != '*') {
				if (*curp == 0) {
					radlog(L_ERR, 
                                               _("%s:%d: unexpected EOF in comment started at line %d"),
						filename, line_num, keep_line);
					return 0;
				} else if (*curp == '\n')
					line_num++;
				++curp;
			}
		} while (*++curp != '/');
		++curp;
		goto again;
	}

	if (*curp == 0)
		return 0;
	
	if (isalpha(*curp)) {
		copy_alpha();
		return expect_string ? T_STRING : keyword();
	}

	if (*curp == '\"') {
		copy_string();
		return T_STRING;
	}
	
	if (isdigit(*curp)) {
		if (copy_digit()) {
			/* IP address */
			cclval.ipaddr = ipstr2long(cclval.string);
			return T_IPADDR;
		}
		cclval.number = strtol(cclval.string, NULL, 0);
		return T_NUMBER;
	} 

	if (*curp == ';') {
		curp++;
		return EOL;
	}
	
	return *curp++;
}

void
putback(tok, length)
	char *tok;
	int length;
{
	if (length > curp - buffer) {
		radlog(L_CRIT, 
                       _("INTERNAL ERROR parsing %s near %d: out of putback space"),
			filename, line_num);
		return;
	}	
	while (length--)	
		*--curp = tok[length];		
}

void
skipws()
{
	while (*curp && isspace(*curp)) {
		if (*curp == '\n')
			line_num++;
		curp++;
	}
}

void
skipline()
{
	while (*curp && *curp != '\n')
		curp++;
}

void
skipstmt()
{
	int c;
	while ((c = cclex()) != 0 && c != EOL)
		;
}

int
isword(c)
	int c;
{
	return isalnum(c) || c == '_' || c == '-';
}

void
copy_alpha()
{
	char * p = cclval.string;
	
	do {
		if (p >= cclval.string + sizeof(cclval.string)) {
			radlog(L_ERR, _("%s:%d: token too long"),
			    filename, line_num);
			break;
		}
		*p++ = *curp++;
	} while (*curp && isword(*curp));
	*p = 0;
}

void
copy_string()
{
	char * p = cclval.string;
	int quote = *curp++;

	while (*curp) {
		if (*curp == quote) {
			curp++;
			break;
		}
		if (p >= cclval.string + sizeof(cclval.string)) {
			radlog(L_ERR, _("%s:%d: token too long"),
			    filename, line_num);
			break;
		}
		*p++ = *curp++;
	} 
	*p = 0;
}

int
copy_digit()
{
	int dot = 0;
	char *p = cclval.string;

	if (*curp == '0') {
		if (curp[1] == 'x' || curp[1] == 'X') {
			*p++ = *curp++;
			*p++ = *curp++;
		}
	}
	
	do {
		if (p >= cclval.string + sizeof(cclval.string)) {
			radlog(L_ERR, _("%s:%d: token too long"),
			    filename, line_num);
			break;
		}
		if ((*p++ = *curp++) == '.')
			dot++;
	} while (*curp && (isdigit(*curp) || *curp == '.'));
	*p = 0;
	return dot;
}

int
get_config()
{
	struct stat st;
	int fd;
	extern int ccdebug;
	Channel *mark;
	
	filename = mkfilename(radius_dir, RADIUS_CONFIG);
	if (stat(filename, &st)) {
		radlog(L_ERR|L_PERROR, _("can't stat `%s'"), filename);
		efree(filename);
		return -1;
	}
	fd = open(filename, O_RDONLY);
	if (fd == -1) {
		if (errno != ENOENT)
			radlog(L_ERR|L_PERROR, 
				_("can't open config file `%s'"), filename);
		efree(filename);
		return -1;
	}
	buffer = emalloc(st.st_size+1);
	
	read(fd, buffer, st.st_size);
	buffer[st.st_size] = 0;
	close(fd);
	curp = buffer;

	
#ifdef USE_SNMP
        snmp_free_communities();
	snmp_free_acl();
#endif

	radlog(L_INFO, _("reading %s"), filename);
	line_num = 1;

	if (strncmp(curp, "#debug", 6) == 0) {
/* Note: can't check YYDEBUG here, because some yaccs (namely, sun's)
 *       define YYDEBUG after including code block
 */	
#if defined(YACC_DEBUG)
		ccdebug = 1;
#else
		radlog(L_WARN,
		    _("%s:%d: #debug ignored: radiusd compiled without parser debugging support"),
		    filename, line_num);
#endif
		debug_config = 1;
	} else {
#if defined(YACC_DEBUG)
		ccdebug = 0;
#endif
		debug_config = 0;
	}

	mark = log_mark();
	
	/* Parse configuration */
	ccparse();

	/* Clean up the things */
	efree(filename);
	efree(buffer);
	log_release(mark);
	
#ifdef USE_SNMP
	free_netlist();
#endif
#ifdef USE_SERVER_GUILE
	scheme_end_reconfig();
#endif
	first_time = 0;
        radlog(L_INFO, _("ready"));
	return 0;
}	

void
asgn(base, value, type, once)
	void *base;
	Value *value;
	int type;
	int once;
{
	struct servent *s;
	UINT4 ipaddr;
	
	switch (type) {
	case AT_PORT:
		switch (value->type) {
		case AT_INT:
			type = AT_INT;
			break;
		case AT_STRING:
			  s = getservbyname(value->v.string, "udp");
			  if (s) 
				  value->v.number = ntohs(s->s_port);
			  else {
				  radlog(L_ERR, 
                                         _("%s:%d: no such service: %s"),
					 filename, line_num,
					 value->v.string);
				  return;
			  }
			  type = value->type = AT_INT;
			  break;
		default:
			break;
		}
		break;
			
	case AT_IPADDR:
		switch (value->type) {
		case AT_IPADDR:
			break;
		case AT_INT:
			type = AT_IPADDR;
			break;
		case AT_STRING:
			ipaddr = get_ipaddr(value->v.string);
			if (ipaddr == 0) {
				radlog(L_ERR, 
				       _("%s:%d: unknown host: %s"),
				       filename, line_num,
				       value->v.string);
			}
			value->v.ipaddr = ipaddr;
			value->type = AT_IPADDR;
			break;
		default:
			break;
		}
	}
	
	if (type != value->type) {
		radlog(L_ERR, 
		       _("%s:%d: wrong datatype (should be %s)"),
		       filename, line_num, typestr[type]);
		return;
	}

#define check_once(c) \
	if (once && !first_time && (c))\
		schedule_restart();
	
	switch (type) {
	case AT_INT:
		check_once(*(int*) base != value->v.number);
		*(int*) base = value->v.number;
		break;
	case AT_STRING:
		check_once(*(char**)base == NULL ||
			   strcmp(*(char**)base, value->v.string));
		replace_string((char**)base, value->v.string);
		break;
	case AT_IPADDR:
		check_once(*(UINT4*) base != value->v.ipaddr);
		*(UINT4*) base = value->v.ipaddr;
		break;
	case AT_BOOL:
		check_once(*(int*) base != value->v.bool);
		*(int*) base = value->v.bool;
		break;
	default:
		radlog(L_CRIT,
		       _("INTERNAL ERROR at %s:%d: unknown datatype %d"),
		       __FILE__, __LINE__, type);
	}
}

#ifdef USE_SNMP

char *
ident_string(str)
	char *str;
{

	return estrdup(str);
}

void
add_netlist(name, list)
	char *name;
	ACL *list;
{
	Netlist *p = emalloc(sizeof(*p));
	p->next = netlist;
	p->name = estrdup(name);
	p->acl = list;
	netlist = p;
}

void
free_netlist()
{
	Netlist *p, *next;

	for (p = netlist; p; ) {
		next = p->next;
		free_acl(p->acl);
		efree(p->name);
		efree(p);
		p = next;
	}
	netlist = NULL;
}

ACL *
find_netlist(name)
	char *name;
{
	Netlist *p;

	for (p = netlist; p; p = p->next)
		if (strcmp(p->name, name) == 0) 
			return p->acl;

	return NULL;
}

#endif

int
ccerror(s)
	char *s;
{
	radlog(L_ERR, "%s:%d: %s", filename, line_num, s);
}
		


